HDU 3649 New Game

New Game

Problem Description

While ZSTU’s acmers were coding, coach Yehr was so bored that he created a new game to kill time. And the game is called “Yehr Game” because of the inventer.

Yehr Game is a board game involving two players. It is played on a board with 40 squares arranged in an ten-by-four grid. At the beginning of the game each player controls four pieces: one acm, one bahamas, one cab and one daze. If one player has no pieces
to move, he lost the game.

Setup:

Yehr Game is played on a rectangle board of ten rows and four columns. The pieces are divided, by convention, into red and black sets. The players are referred to as "Red" and "Black", and each begins the game with four pieces of the specified color. These
consist of one acm, one bahamas, one cab and one daze.

Movement:

First, they setup their pieces on the board.

(1) the piece red acm can be placed on A1~,A2,A3,A4,A5;the piece black acm A6~A10;

(2) the piece red bahamas can place on B1~B5; the piece black Bahamas B6~B10;

(3) the piece red cab can place on C1~C5; the piece black cab C6~C10;

(4) the piece red daze cab can place on D1~D5; the piece black daze D6~D10;

Second, they determine who moves first by dice. After the initial move, the players alternately move one piece at a time.

Each chess piece has its own style of moving.

(1) Acm can only move one direction: red from left to right; black from right to left. Acm can only move to the next square. If one player’s acm moves to a square with the opponent acm, he win the game.

(2) Bahamas and cab can move two direction: from left to right or from right to left. And they can move any number of squares but may not leap over other pieces.

(3) Daze can only move one direction: red from right to left; black from left to right.Daze can only move to the next square. In order to win the game, every clever player places the red daze on d5 and the black on d6.

Of Course, we assume that all players are clever.

Input

The input contains several test cases.

Each test case contains three lines:

First line contains one integer number 0 or 1: 0 indicated red move first and 1 black first.

Second line contains four integer numbers r1, r2, r3, r4 indicating the four red pieces’ square. For example, r3=3 indicating the red cab on C3.

Third line contains four integer numbers k1, k2, k3, k4 indicating the four black pieces’ square. For example, k1=9 indicating the black acm on A9.

We assume that r4 is always 5, and K4 is 6.

Output

For each test case, if red win print Red in a single line, else print Black.

Sample Input

0
4 5 5 5
7 6 6 6

Sample Output

Red

题目大意:

首先告诉你0或1,0表示红色先手,1表示黑色先手,接下来四个数字表示 红方 A,B,C,D四个子的位置,在接下来四个数字表示黑方 A,B,C,D四个子的位置。

游戏规则如下:

(1) the piece red acm can be placed on A1~,A2,A3,A4,A5;the piece black acm A6~A10;

(2) the piece red bahamas can place on B1~B5; the piece black Bahamas B6~B10;

(3) the piece red cab can place on C1~C5; the piece black cab C6~C10;

(4) the piece red daze cab can place on D1~D5; the piece black daze D6~D10;

解题思路:点击打开链接

SG函数

记a=k1-r1    b=k2-r2-1   c=k3-r3-1则

D:r4和k4不属于SG游戏,因为在D这个游戏里,两个玩家是互相独立的。所以r4和k4代表各自的机会,通俗的说就是我们玩魂斗罗时候的“命”

B,C:这两个游戏的SG函数都是b,c 即一个nim子游戏。

A:此游戏的SG函数值为a%2

证明D:当A,B,C游戏已经决定败局时,先手可以在D中进行一次操作(称“缓冲”),

即ABC的败局扭转给后手。显然后手也只能在D中操作挽回败局。故谁在D

中的缓冲区大谁就必胜。通俗的说就是局势以定的时候玩家拼命,谁命多,

谁就胜了。

证明A:当A中两个棋子重合时后手败(被吃子)a=0 sg(A)=0

否则,a的状态只能到达a-1所以sg(A)=a%2

证明B:显然b=0时必败,sg(B)=0。当然此时先手可以增加b的值来苟延残喘,但后

手下一步操作只要再把b减到0,一直下去,先手不能再增加时,还是败了。

然而b>0时的状态不好说,如果我们只考虑b只能减小,那不就成了nim子游

戏了吗。事实上b的增大操作我们称为无效操作,因为处于优势的玩家可以

不靠增加b来取状态,处于劣势的玩家即使增加了b,下一玩家再取回来就可

以了。所以B与NIM子游戏等价。

证明C:同B

解题代码:

#include <iostream>
#include <cstdio>
using namespace std;

int red[10],black[10],first;

int solve(){
    if(black[1]-red[1]==1) return first;
    if(red[4]-1>10-black[4]) return 0;
    if(red[4]-1<10-black[4]) return 1;
    int sg=0;
    sg^=(black[2]-red[2]-1);
    sg^=(black[3]-red[3]-1);
    sg^=(black[1]-red[1])%2;
    if(sg) return first;
    else return first^1;
}

int main(){
    while(scanf("%d",&first)!=EOF){
        for(int i=1;i<=4;i++) scanf("%d",&red[i]);
        for(int i=1;i<=4;i++) scanf("%d",&black[i]);
        if ( !solve() ) printf("Red\n");
        else printf("Black\n");
    }
    return 0;
}

HDU 3649 New Game

时间: 2024-08-14 05:31:57

HDU 3649 New Game的相关文章

HDU 6203 ping ping ping [LCA,贪心,DFS序,BIT(树状数组)]

题目链接:[http://acm.hdu.edu.cn/showproblem.php?pid=6203] 题意 :给出一棵树,如果(a,b)路径上有坏点,那么(a,b)之间不联通,给出一些不联通的点对,然后判断最少有多少个坏点. 题解 :求每个点对的LCA,然后根据LCA的深度排序.从LCA最深的点对开始,如果a或者b点已经有点被标记了,那么continue,否者标记(a,b)LCA的子树每个顶点加1. #include<Bits/stdc++.h> using namespace std;

HDU 5542 The Battle of Chibi dp+树状数组

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5542 题意:给你n个数,求其中上升子序列长度为m的个数 可以考虑用dp[i][j]表示以a[i]结尾的长度为j的上升子序列有多少 裸的dp是o(n2m) 所以需要优化 我们可以发现dp的第3维是找比它小的数,那么就可以用树状数组来找 这样就可以降低复杂度 #include<iostream> #include<cstdio> #include<cstring> #include

hdu 1207 汉诺塔II (DP+递推)

汉诺塔II Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4529    Accepted Submission(s): 2231 Problem Description 经典的汉诺塔问题经常作为一个递归的经典例题存在.可能有人并不知道汉诺塔问题的典故.汉诺塔来源于印度传说的一个故事,上帝创造世界时作了三根金刚石柱子,在一根柱子上从下往

[hdu 2102]bfs+注意INF

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2102 感觉这个题非常水,结果一直WA,最后发现居然是0x3f3f3f3f不够大导致的--把INF改成INF+INF就过了. #include<bits/stdc++.h> using namespace std; bool vis[2][15][15]; char s[2][15][15]; const int INF=0x3f3f3f3f; const int fx[]={0,0,1,-1};

HDU 3555 Bomb (数位DP)

数位dp,主要用来解决统计满足某类特殊关系或有某些特点的区间内的数的个数,它是按位来进行计数统计的,可以保存子状态,速度较快.数位dp做多了后,套路基本上都差不多,关键把要保存的状态给抽象出来,保存下来. 简介: 顾名思义,所谓的数位DP就是按照数字的个,十,百,千--位数进行的DP.数位DP的题目有着非常明显的性质: 询问[l,r]的区间内,有多少的数字满足某个性质 做法根据前缀和的思想,求出[0,l-1]和[0,r]中满足性质的数的个数,然后相减即可. 算法核心: 关于数位DP,貌似写法还是

HDU 5917 Instability ramsey定理

http://acm.hdu.edu.cn/showproblem.php?pid=5917 即世界上任意6个人中,总有3个人相互认识,或互相皆不认识. 所以子集 >= 6的一定是合法的. 然后总的子集数目是2^n,减去不合法的,暴力枚举即可. 选了1个肯定不合法,2个也是,3个的话C(n, 3)枚举判断,C(n, 4), C(n, 5) #include <bits/stdc++.h> #define IOS ios::sync_with_stdio(false) using name

hdu 6166 Senior Pan

地址:http://acm.split.hdu.edu.cn/showproblem.php?pid=6166 题目: Senior Pan Time Limit: 12000/6000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others)Total Submission(s): 245    Accepted Submission(s): 71 Problem Description Senior Pan fails i

2017中国大学生程序设计竞赛 - 网络选拔赛 HDU 6155 Subsequence Count 矩阵快速幂

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=6155 题意: 题解来自:http://www.cnblogs.com/iRedBean/p/7398272.html 先考虑dp求01串的不同子序列的个数. dp[i][j]表示用前i个字符组成的以j为结尾的01串个数. 如果第i个字符为0,则dp[i][0] = dp[i-1][1] + dp[i-1][0] + 1,dp[i][1] = dp[i-1][1] 如果第i个字符为1,则dp[i][1

HDU 1513 Palindrome:LCS(最长公共子序列)or 记忆化搜索

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1513 题意: 给你一个字符串s,你可以在s中的任意位置添加任意字符,问你将s变成一个回文串最少需要添加字符的个数. 题解1(LCS): 很神奇的做法. 先求s和s的反串的LCS,也就是原串中已经满足回文性质的字符个数. 然后要变成回文串的话,只需要为剩下的每个落单的字符,相应地插入一个和它相同的字符即可. 所以答案是:s.size()-LCS(s,rev(s)) 另外,求LCS时只会用到lcs[i-